﻿package com.actionsnippet.qbox{
	
	import flash.display.*
	import flash.events.*;
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	import Box2D.Dynamics.Joints.*;
	
	public class BoxObject extends QuickObject {
				   
		public function BoxObject(qbox:QuickBox2D, params:Object){
			super(qbox, params);
		}
		
		override protected function defaultParams(p:Object):void{
			p.width = 1;
			p.height = 1;
		}
		
		protected override function build():void{
			var p:Object = params;
			
			var boxDef:b2PolygonDef = new b2PolygonDef();
			 
			boxDef.SetAsBox(p.width / 2, p.height / 2);
		
			boxDef.density = p.density;
			boxDef.friction = p.friction;
			boxDef.restitution = p.restitution;
			
			if (p.skin){
			    bodyDef.userData = new p.skin();
			}else{
				bodyDef.userData = new Sprite();
				with(bodyDef.userData.graphics){
					lineStyle(0,p.lineColor, p.lineAlpha);
					beginFill(p.fillColor, p.fillAlpha);
					drawRect(-5,-5,10,10);
				}
			}
			bodyDef.userData.width=p.width * 30;
			bodyDef.userData.height=p.height * 30;
			
			body =w.CreateBody(bodyDef);
			body.CreateShape(boxDef);
			
		}
	}
}