﻿package com.actionsnippet.qbox{
	
	import flash.display.*
	import flash.events.*;
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	import Box2D.Dynamics.Joints.*;
	
	public class CircleObject extends QuickObject {
				   
		public function CircleObject(qbox:QuickBox2D, params:Object){
			super(qbox, params);
		}
		
		override protected function defaultParams(p:Object):void{
			p.radius = .5;
		}
		
		protected override function build():void{
			 
			var p:Object = params;
			
			var circDef:b2CircleDef = new b2CircleDef();
			circDef.radius = p.radius;
			circDef.density = p.density;
			circDef.friction = p.friction;
			circDef.restitution = p.restitution;
			 
			if (p.skin){
			    bodyDef.userData = new p.skin();
			}else{
				bodyDef.userData = new Sprite();
				with(bodyDef.userData.graphics){
					lineStyle(0,p.lineColor, p.lineAlpha);
					beginFill(p.fillColor, p.fillAlpha);
					drawCircle(0,0,10)
				}
			}
			bodyDef.userData.width=p.radius * 60;
			bodyDef.userData.height=p.radius* 60;
			
			body = w.CreateBody(bodyDef);
			body.CreateShape(circDef);
			 
		}
	}
}