﻿package com.actionsnippet.qbox{
	
	import flash.display.*
	import flash.events.*;
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	import Box2D.Dynamics.Joints.*;
	
	public class PolyObject extends QuickObject {
				   
		public function PolyObject(qbox:QuickBox2D, params:Object){
			super(qbox, params);
		}
		
		override protected function defaultParams(p:Object):void{
			p.verts = [[-.5, -1, 1, -1, 1, 1, -1, 1]];
		}
		
		protected override function build():void{
			 
			var p:Object = params;
			 
			
			if (p.skin){
					bodyDef.userData = new p.skin();
			}else{
					bodyDef.userData = new Sprite();
			}
			body = w.CreateBody(bodyDef);
				
			for (var j:int = 0; j<p.verts.length; j++){
				var polyDef:b2PolygonDef = new b2PolygonDef();
				
				polyDef.vertexCount = int(p.verts[j].length / 2);
				
				if (p.verts[j][i] is b2Vec2){
						polyDef.vertices = p.verts[j];
				}else{
					var inc:int = 0;
					for (var i:int = 0; i<p.verts[j].length; i+=2){
						polyDef.vertices[inc].Set(p.verts[j][i], p.verts[j][i + 1]);
						inc++;
					}
				}
				polyDef.density = p.density;
				polyDef.friction = p.friction;
				polyDef.restitution = p.restitution;
				
				if (!p.skin){
					with(bodyDef.userData.graphics){
							lineStyle(0,p.lineColor, p.lineAlpha);
					        beginFill(p.fillColor, p.fillAlpha);
					}
					for (i  =0; i<polyDef.vertexCount; i++){
						with(bodyDef.userData.graphics){
							if (i == 0){
								moveTo(polyDef.vertices[i].x * 30, polyDef.vertices[i].y * 30);
							}else{
								lineTo(polyDef.vertices[i].x * 30, polyDef.vertices[i].y * 30);
							}
						}
					}
					bodyDef.userData.graphics.endFill();
				}
				body.CreateShape(polyDef);
			}
		}
	}
}